/*
 * Misc. functions for MacGate.
 */

#include "MacGate.h"

char *in_ntoa           (__u32 in);

/*
 * Print the LocalTalk to IP node map.
 */
void PrintList (struct ltip_list *LTNodes)
{
        struct ltip_list *current;

        if(LTNodes == NULL)
                return;

        current = LTNodes;
        while(current != NULL)
        {
                printf("IP %s", in_ntoa(current->ip));
                printf(" - Net:Node %d:%d\n", current->sat_addr.s_net, current->sat_addr.s_node);
                current = current->next;
        }
        return;
}

char *in_ntoa(__u32 in)
{
        static char buff[18];
        char *p;

        p = (char *) &in;
        sprintf(buff, "%d.%d.%d.%d",
                (p[0] & 255), (p[1] & 255), (p[2] & 255), (p[3] & 255));
        return(buff);
}

/*
 * Get the Hardware address of a given device by name.
 */
int GetHWaddrByDev (char name[], struct sockaddr *hwaddr)
{
        struct ifreq ifreq;
        int SockFD;

        SockFD = socket(AF_INET, SOCK_DGRAM, 0);
        if(SockFD < 0)
        {
                perror("GetHWaddrByDev: socket()");
                return(0);
        }

        /*
         * Get the hardware address.
         */
        strcpy(ifreq.ifr_name, name);
        memset (&ifreq.ifr_hwaddr, 0, sizeof (struct sockaddr));
        if (ioctl (SockFD, SIOCGIFHWADDR, &ifreq) < 0)
        {
                perror("SIOCGIFHWADDR:");
                return 0;
        }

        memcpy (hwaddr, &ifreq.ifr_hwaddr, sizeof (struct sockaddr));
        return 1;
}
